// TJC implementation of procedure compileproc_string_is_java_integer
package tjc;
import tcl.lang.*;

public class CompileprocStringIsJavaIntegerCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $tstr == ""
            TclObject tmp0 = getVarScalar(interp, "tstr", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            if (!tmp1.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: string is integer $tstr
                TclObject[] objv2 = TJC.grabObjv(interp, 4);
                TclObject tmp3;
                try {
                    // Arg 0 constant: string
                    objv2[0] = const0;
                    // Arg 1 constant: is
                    objv2[1] = const1;
                    // Arg 2 constant: integer
                    objv2[2] = const2;
                    // Arg 3 variable: $tstr
                    tmp3 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    tmp3.preserve();
                    objv2[3] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[3];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 4);
                }
            } // End Invoke: string
            TclObject tmp4 = interp.getResult();
            ExprValue tmp5 = evs1;
            if ( tmp4.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp5, tmp4);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp5, tmp4);
            }
            // End Unary operator: !
            tmp1.setIntValue(tmp5.getBooleanValue(interp));
            } else {
            tmp1.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp6 = ( tmp1.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set min -2147483648.0
            setVarScalar(interp, "min", const4, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set max 2147483647.0
            setVarScalar(interp, "max", const5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tstr [...]
            TclObject tmp7;
            { // Invoke: string trim $tstr
                TclObject[] objv8 = TJC.grabObjv(interp, 3);
                TclObject tmp9;
                try {
                    // Arg 0 constant: string
                    objv8[0] = const0;
                    // Arg 1 constant: trim
                    objv8[1] = const6;
                    // Arg 2 variable: $tstr
                    tmp9 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    tmp9.preserve();
                    objv8[2] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv8, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp9 = objv8[2];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 3);
                }
            } // End Invoke: string
            tmp7 = interp.getResult();
            setVarScalar(interp, "tstr", tmp7, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... else ...
            { // Invoke: regexp ... $tstr
                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                TclObject tmp11;
                try {
                    // Arg 0 constant: regexp
                    objv10[0] = const7;
                    // Arg 1 constant: ...
                    objv10[1] = const8;
                    // Arg 2 variable: $tstr
                    tmp11 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    tmp11.preserve();
                    objv10[2] = tmp11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv10, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp11 = objv10[2];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 3);
                }
            } // End Invoke: regexp
            TclObject tmp12 = interp.getResult();
            ExprValue tmp13 = evs0;
            TJC.exprInitValue(interp, tmp13, tmp12);
            boolean tmp14 = tmp13.getBooleanValue(interp);
            if ( tmp14 ) {
                { // Invoke: set fnum "0.0"
                    setVarScalar(interp, "fnum", const9, compiledLocals, 3);
                } // End Invoke: set
            } else {
                { // Invoke: regexp ... $tstr
                    TclObject[] objv15 = TJC.grabObjv(interp, 3);
                    TclObject tmp16;
                    try {
                        // Arg 0 constant: regexp
                        objv15[0] = const7;
                        // Arg 1 constant: ...
                        objv15[1] = const10;
                        // Arg 2 variable: $tstr
                        tmp16 = getVarScalar(interp, "tstr", compiledLocals, 0);
                        tmp16.preserve();
                        objv15[2] = tmp16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv15, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp16 = objv15[2];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 3);
                    }
                } // End Invoke: regexp
                TclObject tmp17 = interp.getResult();
                ExprValue tmp18 = evs0;
                TJC.exprInitValue(interp, tmp18, tmp17);
                boolean tmp19 = tmp18.getBooleanValue(interp);
                if ( tmp19 ) {
                    { // Invoke: set fnum "${tstr}.0"
                        TclObject tmp20;
                        StringBuffer sbtmp21 = new StringBuffer(64);
                        tmp20 = getVarScalar(interp, "tstr", compiledLocals, 0);
                        sbtmp21.append(tmp20.toString());
                        sbtmp21.append(".0");
                        tmp20 = TclString.newInstance(sbtmp21);
                        setVarScalar(interp, "fnum", tmp20, compiledLocals, 3);
                    } // End Invoke: set
                } else {
                    { // Invoke: set is_neg 0
                        setVarScalar(interp, "is_neg", const3, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: set c [...]
                        TclObject tmp22;
                        { // Invoke: string index ${tstr} 0
                            TclObject tmp23 = getVarScalar(interp, "tstr", compiledLocals, 0);
                            String tmp24 = tmp23.toString();
                            TclObject tmp25 = TJC.stringIndex(interp, tmp24, const3);
                            interp.setResult(tmp25);
                        } // End Invoke: string
                        tmp22 = interp.getResult();
                        setVarScalar(interp, "c", tmp22, compiledLocals, 5);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        // Binary operator: () || ()
                        // Binary operator: $c == "+"
                        TclObject tmp26 = getVarScalar(interp, "c", compiledLocals, 5);
                        boolean tmp27 = tmp26.toString().equals("+");
                        ExprValue tmp28 = evs0;
                        tmp28.setIntValue(tmp27);
                        // End Binary operator: ==
                        if (!tmp28.getBooleanValue(interp)) {
                        // Binary operator: $c == "-"
                        TclObject tmp29 = getVarScalar(interp, "c", compiledLocals, 5);
                        boolean tmp30 = tmp29.toString().equals("-");
                        ExprValue tmp31 = evs1;
                        tmp31.setIntValue(tmp30);
                        // End Binary operator: ==
                        tmp28.setIntValue(tmp31.getBooleanValue(interp));
                        } else {
                        tmp28.setIntValue(1);
                        } // End if: !()
                        // End Binary operator: ||
                        boolean tmp32 = ( tmp28.getIntValue() != 0 );
                        if ( tmp32 ) {
                            { // Invoke: if {$c == "-"} ...
                                // Binary operator: $c == "-"
                                TclObject tmp33 = getVarScalar(interp, "c", compiledLocals, 5);
                                boolean tmp34 = tmp33.toString().equals("-");
                                ExprValue tmp35 = evs0;
                                tmp35.setIntValue(tmp34);
                                // End Binary operator: ==
                                boolean tmp36 = ( tmp35.getIntValue() != 0 );
                                if ( tmp36 ) {
                                    { // Invoke: set is_neg 1
                                        setVarScalar(interp, "is_neg", const11, compiledLocals, 4);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: set ptstr [...]
                                TclObject tmp37;
                                { // Invoke: string range $tstr 1 end
                                    TclObject tmp38 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                    String tmp39 = tmp38.toString();
                                    TclObject tmp40 = const11;
                                    tmp40.preserve();
                                    TclObject tmp41 = const12;
                                    TclObject tmp42 = TJC.stringRange(interp, tmp39, tmp40, tmp41);
                                    interp.setResult(tmp42);
                                } // End Invoke: string
                                tmp37 = interp.getResult();
                                setVarScalar(interp, "ptstr", tmp37, compiledLocals, 6);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set ptstr $tstr
                                TclObject tmp43;
                                tmp43 = getVarScalar(interp, "tstr", compiledLocals, 0);
                                setVarScalar(interp, "ptstr", tmp43, compiledLocals, 6);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: set fnum [...]
                        TclObject tmp44;
                        { // Invoke: expr {int($ptstr)}
                            // Math function: int $ptstr
                            TclObject tmp45 = getVarScalar(interp, "ptstr", compiledLocals, 6);
                            ExprValue tmp46 = evs0;
                            TJC.exprInitValue(interp, tmp46, tmp45);
                            TJC.exprIntMathFunction(interp, tmp46);
                            // End Math function: int
                            interp.setResult( tmp46.getIntValue() );
                        } // End Invoke: expr
                        tmp44 = interp.getResult();
                        setVarScalar(interp, "fnum", tmp44, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: if ... ... elseif {$fnum <= 0} ... else ...
                        // Binary operator: $is_neg && ()
                        TclObject tmp47 = getVarScalar(interp, "is_neg", compiledLocals, 4);
                        ExprValue tmp48 = evs0;
                        TJC.exprInitValue(interp, tmp48, tmp47);
                        if (tmp48.getBooleanValue(interp)) {
                        // Binary operator: $fnum == $min
                        TclObject tmp49 = getVarScalar(interp, "fnum", compiledLocals, 3);
                        ExprValue tmp50 = evs1;
                        TJC.exprInitValue(interp, tmp50, tmp49);
                        TclObject tmp51 = getVarScalar(interp, "min", compiledLocals, 1);
                        ExprValue tmp52 = evs2;
                        TJC.exprInitValue(interp, tmp52, tmp51);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp50, tmp52);
                        // End Binary operator: ==
                        tmp48.setIntValue(tmp50.getBooleanValue(interp));
                        } else {
                        tmp48.setIntValue(0);
                        } // End if: $is_neg
                        // End Binary operator: &&
                        boolean tmp53 = ( tmp48.getIntValue() != 0 );
                        if ( tmp53 ) {
                            { // Invoke: set fnum $min
                                TclObject tmp54;
                                tmp54 = getVarScalar(interp, "min", compiledLocals, 1);
                                setVarScalar(interp, "fnum", tmp54, compiledLocals, 3);
                            } // End Invoke: set
                        } else {
                            // Binary operator: $fnum <= 0
                            TclObject tmp55 = getVarScalar(interp, "fnum", compiledLocals, 3);
                            ExprValue tmp56 = evs0;
                            TJC.exprInitValue(interp, tmp56, tmp55);
                            ExprValue tmp57 = evs1;
                            tmp57.setIntValue(0);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LEQ, tmp56, tmp57);
                            // End Binary operator: <=
                            boolean tmp58 = ( tmp56.getIntValue() != 0 );
                            if ( tmp58 ) {
                                { // Invoke: return 0
                                    interp.resetResult();
                                    interp.setResult(const3);
                                    if ( true ) { return; }
                                } // End Invoke: return
                            } else {
                                { // Invoke: if {$is_neg} ...
                                    TclObject tmp59 = getVarScalar(interp, "is_neg", compiledLocals, 4);
                                    boolean tmp60 = TJC.getBoolean(interp, tmp59);
                                    if ( tmp60 ) {
                                        { // Invoke: set fnum [...]
                                            TclObject tmp61;
                                            { // Invoke: expr {-1.0 * $fnum}
                                                // Binary operator: () * $fnum
                                                // Unary operator: - 1.0
                                                ExprValue tmp62 = evs0;
                                                tmp62.setDoubleValue(-1.0);
                                                // End Unary operator: -
                                                TclObject tmp63 = getVarScalar(interp, "fnum", compiledLocals, 3);
                                                ExprValue tmp64 = evs1;
                                                TJC.exprInitValue(interp, tmp64, tmp63);
                                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MULT, tmp62, tmp64);
                                                // End Binary operator: *
                                                interp.setResult( tmp62.getDoubleValue() );
                                            } // End Invoke: expr
                                            tmp61 = interp.getResult();
                                            setVarScalar(interp, "fnum", tmp61, compiledLocals, 3);
                                        } // End Invoke: set
                                    }
                                } // End Invoke: if
                            }
                        }
                    } // End Invoke: if
                }
            }
        } // End Invoke: if
        { // Invoke: set fnum [...]
            TclObject tmp65;
            { // Invoke: expr {double($fnum)}
                // Math function: double $fnum
                TclObject tmp66 = getVarScalar(interp, "fnum", compiledLocals, 3);
                ExprValue tmp67 = evs0;
                TJC.exprInitValue(interp, tmp67, tmp66);
                TJC.exprDoubleMathFunction(interp, tmp67);
                // End Math function: double
                interp.setResult( tmp67.getDoubleValue() );
            } // End Invoke: expr
            tmp65 = interp.getResult();
            setVarScalar(interp, "fnum", tmp65, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () && ()
            // Binary operator: $fnum > 0.0
            TclObject tmp68 = getVarScalar(interp, "fnum", compiledLocals, 3);
            ExprValue tmp69 = evs0;
            TJC.exprInitValue(interp, tmp69, tmp68);
            ExprValue tmp70 = evs1;
            tmp70.setDoubleValue(0.0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp69, tmp70);
            // End Binary operator: >
            if (tmp69.getBooleanValue(interp)) {
            // Binary operator: $fnum > $max
            TclObject tmp71 = getVarScalar(interp, "fnum", compiledLocals, 3);
            ExprValue tmp72 = evs1;
            TJC.exprInitValue(interp, tmp72, tmp71);
            TclObject tmp73 = getVarScalar(interp, "max", compiledLocals, 2);
            ExprValue tmp74 = evs2;
            TJC.exprInitValue(interp, tmp74, tmp73);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp72, tmp74);
            // End Binary operator: >
            tmp69.setIntValue(tmp72.getBooleanValue(interp));
            } else {
            tmp69.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (!tmp69.getBooleanValue(interp)) {
            // Binary operator: () && ()
            // Binary operator: $fnum < 0.0
            TclObject tmp75 = getVarScalar(interp, "fnum", compiledLocals, 3);
            ExprValue tmp76 = evs1;
            TJC.exprInitValue(interp, tmp76, tmp75);
            ExprValue tmp77 = evs2;
            tmp77.setDoubleValue(0.0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp76, tmp77);
            // End Binary operator: <
            if (tmp76.getBooleanValue(interp)) {
            // Binary operator: $fnum < $min
            TclObject tmp78 = getVarScalar(interp, "fnum", compiledLocals, 3);
            ExprValue tmp79 = evs2;
            TJC.exprInitValue(interp, tmp79, tmp78);
            TclObject tmp80 = getVarScalar(interp, "min", compiledLocals, 1);
            ExprValue tmp81 = evs3;
            TJC.exprInitValue(interp, tmp81, tmp80);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp79, tmp81);
            // End Binary operator: <
            tmp76.setIntValue(tmp79.getBooleanValue(interp));
            } else {
            tmp76.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            tmp69.setIntValue(tmp76.getBooleanValue(interp));
            } else {
            tmp69.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp82 = ( tmp69.getIntValue() != 0 );
            if ( tmp82 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const11);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_string_is_java_integer");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclDouble.newInstance(-2147483648.0);
        const4.preserve(); const4.preserve();
        const5 = TclDouble.newInstance(2147483647.0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("trim");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("regexp");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("^(\\-|\\+)?(0x|0X)?0+$");
        const8.preserve(); const8.preserve();
        const9 = TclDouble.newInstance(0.0);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("^(\\-|\\+)?[1-9][0-9]*$");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(1);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("end");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr",
        "min",
        "max",
        "fnum",
        "is_neg",
        "c",
        "ptstr"
    };
} // end class CompileprocStringIsJavaIntegerCmd

