
### This routine processes the arguments to prepare
### the arguments for the Java APIs. It will map each
### commandline switches and their respective values
### That boolean switches are processed specially by inserting
### true valuse so that we can pass this value to the Java API.
###
### The  -help switch prints the help message
###
###

package require java

##set edautilsroot  [ java::call System getenv "EDAUTILS_ROOT" ]
##source $edautilsroot/bin/cmdArgs.tcl
##source $edautilsroot/bin/load_designplayer_classes.tcl

java::import com.eu.miscedautils.CommonUtils.Utils
set fs [java::call Utils getFilePathSeparator ]

set edautilsroot  [ java::call System getenv "EDAUTILS_ROOT" ]

if {[string equal -nocase $fs "/"]} {
	source $edautilsroot/bin/cmdArgs.tcl
	source $edautilsroot/bin/init.brigid.tcl
	source $edautilsroot/bin/init.ipxact.tcl
	source $edautilsroot/bin/init.baya.tcl
} else {
	source $edautilsroot\\\\bin\\\\cmdArgs.tcl
	source $edautilsroot\\\\bin\\\\init.brigid.tcl
	source $edautilsroot\\\\bin\\\\init.ipxact.tcl
	source $edautilsroot\\\\bin\\\\init.baya.tcl
}
if {[string equal -nocase $fs "/"]} {
	source $edautilsroot/bin/load_designplayer_classes.tcl
} else {
	source $edautilsroot\\\\bin\\\\load_designplayer_classes.tcl
}

global myshell
set myshell [java::call DesignPlayerBackBone instance]

global bayaroot 
global ipxactroot 
global brigidroot 

set bayaroot [$myshell getBayaRoot]
set ipxactroot [$myshell getIPXACTRoot]
set brigidroot [$myshell getBrigidRoot]

set verilogdescription [java::call FVPDescription  instance ]
set vhdldescription [java::call FVhPDescription  instance ]

#source $edautilsroot/bin/init.baya.tcl
#source $edautilsroot/bin/init.ipxact.tcl
#source $edautilsroot/bin/init.brigid.tcl


